﻿Write-Host "Update RDNConfig Script" -ForegroundColor Cyan
$DisplayNamess = Read-Host "Print SignServer DisplayName"

$ID= (Get-DssEnrollment -DisplayName $DisplayNamess| where {$_.settings['RdnConfig']}).ID
if($ID) {
	$ID | foreach {	
			$tmpID= $_	
			$notinnle = "0"
			[int]$bigorder= "1"
			
			#Проверка на зарегистрированный INNLE
			#Для этого парсим XML
			[xml]$RdnConfig = (Get-DssEnrollment -ID $_ -DisplayName $DisplayNamess).settings['RdnConfig']
			$RdnConfig.ArrayOfSubjectNameComponent.SubjectNameComponent | foreach { $OID = $_.OID ;  if($OID -eq "1.2.643.100.4" ) { $notinnle = "1" }}
			if($notinnle -ne "1"){ 			
				Write-Host "Update RDNConfig for EnrollOOB witch ID $tmpID" -ForegroundColor Cyan 
				
				#Создаем пути к ванильному конфигу и к новому
				$loc = $PSScriptRoot + "\OOB_RdnConfig_"+"$DisplayNamess"+"_With_ID_$tmpID.txt"
				$locnew= $PSScriptRoot + "\NEWOOB_RdnConfig_"+"$DisplayNamess"+"_With_ID_$tmpID.txt"
							
				#Ванила конфиг
				[xml]$RdnConfig = (Get-DssEnrollment -ID $_ -DisplayName $DisplayNamess).settings['RdnConfig']			
				$RdnConfig.ArrayOfSubjectNameComponent.SubjectNameComponent | foreach { 
					$cav="'";$Name=$_.Name; $StringIdentifier = $_.StringIdentifier ; $OID = $_.OID ; $Order =$_.Order ; $IsRequired = $_.IsRequired 
					'DisplayName=' +$cav+$Name+$cav + ' Name=' +$cav+$StringIdentifier+$cav+ ' OID=' +$cav+$OID+$cav+ ' Order='+$cav+$Order+$cav+' Required='+$cav+$IsRequired+$cav>>"$loc" 
				}
				#Новый конфиг
				$RdnConfig.ArrayOfSubjectNameComponent.SubjectNameComponent | foreach { 
					$cav="'";$Name=$_.Name; $StringIdentifier = $_.StringIdentifier ; $OID = $_.OID ; $Order =$_.Order ; $IsRequired = $_.IsRequired 
					'DisplayName=' +$cav+$Name+$cav + ' Name=' +$cav+$StringIdentifier+$cav+ ' OID=' +$cav+$OID+$cav+ ' Order='+$cav+$Order+$cav+' Required='+$cav+$IsRequired+$cav>>"$locnew"
					#Считаем 
					$Order =[int]$Order
					if ($bigorder -lt $Order) {$bigorder= $Order }
				}
				$bigorder= $bigorder +1
				#Дописываем INNLE в новый конфиг
				"DisplayName='ИНН ЮЛ' Name='INNLE'  OID='1.2.643.100.4' Order=$cav$bigorder$cav Required='false'" >>"$locnew" 
				
				#Применяем новый конфиг
				Set-DssEnrollmentOob -DisplayName $DisplayNamess -ID $_  -RdnConfig "$locnew"
				Write-Host "Enroll with ID $tmpID added INNLE " -ForegroundColor Cyan 
				
			}
			else{ Write-Host "Enroll with ID $tmpID already contains INNLE" -ForegroundColor Yellow }
			
		}
	 
}

Restart-DssSignServerInstance -DisplayName $DisplayNamess
	